"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transOptionToAscOption = exports.schemaOptions = void 0;
const asc_1 = require("assemblyscript/cli/asc");
const ascSchemaOptions = Object.entries(asc_1.options).reduce((ret, [key, item]) => {
    // 只检验单个的值，数组不校验
    if (item.type && /[a-z]/.test(item.type)) {
        const schemaType = (() => {
            switch (item.type) {
                case 'b': return 'boolean';
                case 's': return 'string';
                case 'f':
                case 'i': return 'number';
                default: return 'null';
            }
        })();
        Object.assign(ret, {
            [key]: {
                type: schemaType,
                default: item.default,
                description: item.description,
            },
        });
    }
    return ret;
}, {});
exports.schemaOptions = {
    type: 'object',
    properties: Object.assign(Object.assign({}, ascSchemaOptions), { limit: {
            type: ['number', 'string'],
            description: 'Byte limit the size to the wasm file: size <= limit, wasm bundled into js ,or builded into output.wasm',
        }, name: {
            type: 'string',
        }, publicPath: {
            type: 'string',
        }, useInWorker: {
            type: 'boolean',
        } }),
    additionalProperties: true,
};
exports.transOptionToAscOption = (opt) => Object.entries(asc_1.options).reduce((ret, [key, item]) => {
    const value = opt[key];
    if (value && item.type) {
        switch (item.type) {
            case 'b': {
                ret.push(`--${key}`);
                break;
            }
            default: {
                ret.push(`--${key}`, `${value}`);
            }
        }
    }
    return ret;
}, []);
//# sourceMappingURL=option.js.map